<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: models/People/User/User.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_user_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">User.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_USER_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_USER_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;../../../models/Database/Database.h&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;../Person/Person.h&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;../../Article/Book/Book.h&quot;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_user.html">   31</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_user.html">User</a> : <span class="keyword">public</span> <a class="code" href="class_person.html">Person</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="class_i_o_stream.html">IOStream</a>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="comment">// constructors</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <a class="code" href="class_user.html#ae78803d1d577c2450b50cff54bf9ec07">User</a>(</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            std::string name,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            std::string surname,</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            QDate date,</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            std::string email</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    );</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="class_user.html#ae78803d1d577c2450b50cff54bf9ec07">User</a>(</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            std::string email</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    );</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="class_user.html#ae78803d1d577c2450b50cff54bf9ec07">User</a>(<span class="keyword">const</span> <a class="code" href="class_user.html">User</a> &amp;u);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#ace19848c26b4b131c6f7b48d7b146ffc">isAdmin</a>();</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#a691b2225590d655a5ffea2b03402e125">reserveBook</a>(<a class="code" href="class_book.html">Book</a> *book);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#aa194caf9ec2a069de06d7d0b388e6b5d">returnBook</a>(<a class="code" href="class_book.html">Book</a> *book);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#aa01f3ad7431073992a545da9660fa3ad">isBookReservedByUser</a>(<a class="code" href="class_book.html">Book</a> book);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#adb9a76bda3d20fb82db91855be66d620">isBookInWishlist</a>(<a class="code" href="class_book.html">Book</a> book);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="comment">// setters</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_user.html#a003a00af12fe873041488375f8abdccb">setEmail</a>(std::string email);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_user.html#a9647677311d12cea36d96591f31237c6">addBookToWishList</a>(<a class="code" href="class_book.html">Book</a> book);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_user.html#a1f821b3d4a692cf9f51439d428eedc65">removeBookFromWishList</a>(<a class="code" href="class_book.html">Book</a> book);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">// getters</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    std::string <a class="code" href="class_user.html#a00601492ab5e28c33d67a0d49b432150">getEmail</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    std::vector&lt;Book&gt; <a class="code" href="class_user.html#a77b858ec6e7b02a3893613f9ba7fd95a">getWishList</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    std::vector&lt;Book&gt; <a class="code" href="class_user.html#ac60139fa8d8dd4804936ffcb8bfdca45">getLoans</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="comment">// operators</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <a class="code" href="class_user.html">User</a> &amp;<a class="code" href="class_user.html#a2bedf75049198d6218bd77f6df897c99">operator=</a>(<span class="keyword">const</span> <a class="code" href="class_user.html">User</a> &amp;u);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#a2e787f019ae942181d625c94290d5972">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_user.html">User</a> &amp;other) <span class="keyword">const</span>;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_user.html#aed9ecdccccc81a597b3e2aac099a9a2f">operator!=</a>(<span class="keyword">const</span> <a class="code" href="class_user.html">User</a> &amp;other) <span class="keyword">const</span>;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_user.html#ad1d60bd88c6015b93b7449e4cc7bffc8">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_user.html">User</a> &amp;user);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_user.html#ad1d60bd88c6015b93b7449e4cc7bffc8">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_user.html">User</a> *user);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordtype">bool</span> amIAdmin = <span class="keyword">false</span>;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    std::string email;  <span class="comment">// email of user</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <a class="code" href="class_database.html">Database&lt;Book&gt;</a> wishList;  <span class="comment">// list of books user wants to read</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <a class="code" href="class_database.html">Database&lt;Book&gt;</a> loans;  <span class="comment">// list of books loaned to the user</span></div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;};</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="preprocessor">#endif // LIBRARYMGR_USER_H</span></div><div class="ttc" id="class_user_html_aa194caf9ec2a069de06d7d0b388e6b5d"><div class="ttname"><a href="class_user.html#aa194caf9ec2a069de06d7d0b388e6b5d">User::returnBook</a></div><div class="ttdeci">bool returnBook(Book *book)</div><div class="ttdef"><b>Definition:</b> User.cpp:90</div></div>
<div class="ttc" id="class_book_html"><div class="ttname"><a href="class_book.html">Book</a></div><div class="ttdoc">Library book with author, ISBN and status. </div><div class="ttdef"><b>Definition:</b> Book.h:28</div></div>
<div class="ttc" id="class_user_html_a00601492ab5e28c33d67a0d49b432150"><div class="ttname"><a href="class_user.html#a00601492ab5e28c33d67a0d49b432150">User::getEmail</a></div><div class="ttdeci">std::string getEmail() const </div><div class="ttdoc">gets user email </div><div class="ttdef"><b>Definition:</b> User.cpp:61</div></div>
<div class="ttc" id="class_user_html_ac60139fa8d8dd4804936ffcb8bfdca45"><div class="ttname"><a href="class_user.html#ac60139fa8d8dd4804936ffcb8bfdca45">User::getLoans</a></div><div class="ttdeci">std::vector&lt; Book &gt; getLoans() const </div><div class="ttdef"><b>Definition:</b> User.cpp:107</div></div>
<div class="ttc" id="class_i_o_stream_html"><div class="ttname"><a href="class_i_o_stream.html">IOStream</a></div><div class="ttdef"><b>Definition:</b> IOStream.h:42</div></div>
<div class="ttc" id="class_user_html"><div class="ttname"><a href="class_user.html">User</a></div><div class="ttdef"><b>Definition:</b> User.h:31</div></div>
<div class="ttc" id="class_user_html_a1f821b3d4a692cf9f51439d428eedc65"><div class="ttname"><a href="class_user.html#a1f821b3d4a692cf9f51439d428eedc65">User::removeBookFromWishList</a></div><div class="ttdeci">void removeBookFromWishList(Book book)</div><div class="ttdoc">removes book from list of books user wants to read </div><div class="ttdef"><b>Definition:</b> User.cpp:57</div></div>
<div class="ttc" id="class_user_html_a2bedf75049198d6218bd77f6df897c99"><div class="ttname"><a href="class_user.html#a2bedf75049198d6218bd77f6df897c99">User::operator=</a></div><div class="ttdeci">User &amp; operator=(const User &amp;u)</div><div class="ttdoc">operator = User deep copy of person </div><div class="ttdef"><b>Definition:</b> User.cpp:28</div></div>
<div class="ttc" id="class_user_html_a2e787f019ae942181d625c94290d5972"><div class="ttname"><a href="class_user.html#a2e787f019ae942181d625c94290d5972">User::operator==</a></div><div class="ttdeci">bool operator==(const User &amp;other) const </div><div class="ttdoc">equals 2 users by comparing emails </div><div class="ttdef"><b>Definition:</b> User.cpp:37</div></div>
<div class="ttc" id="class_user_html_aed9ecdccccc81a597b3e2aac099a9a2f"><div class="ttname"><a href="class_user.html#aed9ecdccccc81a597b3e2aac099a9a2f">User::operator!=</a></div><div class="ttdeci">bool operator!=(const User &amp;other) const </div><div class="ttdoc">equals 2 users by comparing emails </div><div class="ttdef"><b>Definition:</b> User.cpp:41</div></div>
<div class="ttc" id="class_user_html_a003a00af12fe873041488375f8abdccb"><div class="ttname"><a href="class_user.html#a003a00af12fe873041488375f8abdccb">User::setEmail</a></div><div class="ttdeci">void setEmail(std::string email)</div><div class="ttdef"><b>Definition:</b> User.cpp:49</div></div>
<div class="ttc" id="class_user_html_aa01f3ad7431073992a545da9660fa3ad"><div class="ttname"><a href="class_user.html#aa01f3ad7431073992a545da9660fa3ad">User::isBookReservedByUser</a></div><div class="ttdeci">bool isBookReservedByUser(Book book)</div><div class="ttdef"><b>Definition:</b> User.cpp:99</div></div>
<div class="ttc" id="class_user_html_ad1d60bd88c6015b93b7449e4cc7bffc8"><div class="ttname"><a href="class_user.html#ad1d60bd88c6015b93b7449e4cc7bffc8">User::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;out, const User &amp;user)</div><div class="ttdoc">operator &lt;&lt; printer </div><div class="ttdef"><b>Definition:</b> User.cpp:69</div></div>
<div class="ttc" id="class_database_html"><div class="ttname"><a href="class_database.html">Database&lt; Book &gt;</a></div></div>
<div class="ttc" id="class_user_html_a9647677311d12cea36d96591f31237c6"><div class="ttname"><a href="class_user.html#a9647677311d12cea36d96591f31237c6">User::addBookToWishList</a></div><div class="ttdeci">void addBookToWishList(Book book)</div><div class="ttdoc">appends book to list of books user wants to read </div><div class="ttdef"><b>Definition:</b> User.cpp:53</div></div>
<div class="ttc" id="class_user_html_a691b2225590d655a5ffea2b03402e125"><div class="ttname"><a href="class_user.html#a691b2225590d655a5ffea2b03402e125">User::reserveBook</a></div><div class="ttdeci">bool reserveBook(Book *book)</div><div class="ttdef"><b>Definition:</b> User.cpp:81</div></div>
<div class="ttc" id="class_user_html_adb9a76bda3d20fb82db91855be66d620"><div class="ttname"><a href="class_user.html#adb9a76bda3d20fb82db91855be66d620">User::isBookInWishlist</a></div><div class="ttdeci">bool isBookInWishlist(Book book)</div><div class="ttdef"><b>Definition:</b> User.cpp:103</div></div>
<div class="ttc" id="class_user_html_ae78803d1d577c2450b50cff54bf9ec07"><div class="ttname"><a href="class_user.html#ae78803d1d577c2450b50cff54bf9ec07">User::User</a></div><div class="ttdeci">User(std::string name, std::string surname, QDate date, std::string email)</div><div class="ttdoc">User New Person with email and optional date of birth. </div><div class="ttdef"><b>Definition:</b> User.cpp:20</div></div>
<div class="ttc" id="class_person_html"><div class="ttname"><a href="class_person.html">Person</a></div><div class="ttdoc">Wrap for generic person personal info. </div><div class="ttdef"><b>Definition:</b> Person.h:27</div></div>
<div class="ttc" id="class_user_html_a77b858ec6e7b02a3893613f9ba7fd95a"><div class="ttname"><a href="class_user.html#a77b858ec6e7b02a3893613f9ba7fd95a">User::getWishList</a></div><div class="ttdeci">std::vector&lt; Book &gt; getWishList() const </div><div class="ttdef"><b>Definition:</b> User.cpp:65</div></div>
<div class="ttc" id="class_user_html_ace19848c26b4b131c6f7b48d7b146ffc"><div class="ttname"><a href="class_user.html#ace19848c26b4b131c6f7b48d7b146ffc">User::isAdmin</a></div><div class="ttdeci">bool isAdmin()</div><div class="ttdoc">isAdmin checks whether user is an admin </div><div class="ttdef"><b>Definition:</b> User.cpp:45</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_1ae4179d5e953611aae20c997279e02c.html">models</a></li><li class="navelem"><a class="el" href="dir_34f7514774f7ab8415d66ae1b257c12f.html">People</a></li><li class="navelem"><a class="el" href="dir_b7750155f0acaeb7a6660d535a8019ac.html">User</a></li><li class="navelem"><b>User.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
